import {
  select,
  csv,
  scaleLinear,
  scaleTime,
  extent,
  axisLeft,
  axisBottom,
  line,
  max
} from 'd3';

//redering svg tag from html
//const svg = select('svg');

//const width = +svg.attr('width');
//const height = +svg.attr('height');

// set the dimensions and margins of the graph
var margin = {top: 10, right: 30, bottom: 30, left: 60},
    width = 460 - margin.left - margin.right,
    height = 400 - margin.top - margin.bottom;

// append the svg object to the body of the page
var svg = d3.select("#my_dataviz")
  .append("svg")
    .attr("width", width + margin.left + margin.right)
    .attr("height", height + margin.top + margin.bottom)
  .append("g")
    .attr("transform",
          "translate(" + margin.left + "," + margin.top + ")");


/*const update = data => { 
  console.log("here");
		console.log(data);
    // Add X axis --> it is a date format
    var x = d3.scaleTime()
      .domain(d3.extent(data, function(d) { return d.date; }))
      .range([ 0, width ]);
    svg.append("g")
      .attr("transform", "translate(0," + height + ")")
      .call(d3.axisBottom(x));

    // Add Y axis
    var y = d3.scaleLinear()
      .domain([0, d3.max(data, function(d) { return +d.value; })])
      .range([ height, 0 ]);
    svg.append("g")
      .call(d3.axisLeft(y));

    // Add the line
    svg.append("path")
      .datum(data)
      .attr("fill", "none")
      .attr("stroke", "steelblue")
      .attr("stroke-width", 1.5)
      .attr("d", d3.line()
        .x(function(d) { return x(d.date) })
        .y(function(d) { return y(d.value) })
        )
};*/

//Read the data
//d3.json("data.json").then((data) => { 
d3.csv("https://raw.githubusercontent.com/holtzy/data_to_viz/master/Example_dataset/3_TwoNumOrdered_comma.csv", 

  // When reading the csv, I must format variables:
  function(d){
    return { date : d3.timeParse("%Y-%m-%d")(d.date), value : d.value }
  }).then(
  //console.log(data);
  
  
  // Now I can use this dataset:
  function (data) {
    console.log(data);
    // Add X axis --> it is a date format
    var x = d3.scaleTime()
      .domain(d3.extent(data, function(d) { return d.date; }))
      .range([ 0, width ]);
    svg.append("g")
      .attr("transform", "translate(0," + height + ")")
      .call(d3.axisBottom(x));

    // Add Y axis
    var y = d3.scaleLinear()
      .domain([0, d3.max(data, function(d) { return +d.value; })])
      .range([ height, 0 ]);
    svg.append("g")
      .call(d3.axisLeft(y));

    // Add the line
    svg.append("path")
      .datum(data)
      .attr("fill", "none")
      .attr("stroke", "steelblue")
      .attr("stroke-width", 1.5)
      .attr("d", d3.line()
        .x(function(d) { return x(d.date) })
        .y(function(d) { return y(d.value) })
        )
  })
  
  
  //update(data);
  //update2(data);
  
//});


//})


/*let newData = new Array();
d3.json("data.json").then((data) => { 
  let i = 0;
  //Trier les données
  data.forEach(function(d){    
    let isPresent = false;
  	let j = 0;
    let index;
    newData.forEach(function(dd){      
      if(newData[j].genre == data[i].genre){
        isPresent = true;
        index = j;
      }      
    	j++;
    });
    
    if(isPresent){
      newData[index].nb_musique = newData[index].nb_musique+1;
    }
    else{
      
      if(!data[i].genre ==""){
        if(!data[i].dateRelease ==""){
          const date = new Date(data[i].dateRelease);
          console.log(date.getFullYear());
          newData.push({
                 "genre": data[i].genre,
                 "date": date.getFullYear(),
            		 "nb_musique" : 1
          });
        }
      }
    }
    isPresent = false;
    i++;
    
    
    //Trier les dates par ordre croissant 
  	newData.sort(function (a, b) {
            return d3['ascending'](
              +a.date,
              +b.date
            );
    })
    
  });
    
  
  console.log(newData);
  
	update(newData);
  //render(newData);
    
});*